/* eslint-disable class-methods-use-this */
<template>
    <div class="home d-flex flex-column h-100" v-if="contextService.configLoaded">
      <Header v-if="showHeader"/>
      <div class="main-area flex-grow-1 flex-row" v-if="isMapContextLoaded">
        <Map/>
      </div>
      <FeatureListPanel v-if="contextService.tablelayer" :layer="contextService.tablelayer" v-bind:expanded="true"/>
      <Footer v-if="showFooter"/>
      <AlertPanel/>
      <LoadingPanel/>
        <GroupLayerInfos
        v-if="contextService.currentAction=='infoGroup'"
        v-bind:layer="contextService.currentActionTarget"
        />
    <SingleLayerInfos
        v-if="contextService.currentAction=='infoLayer'"
        v-bind:layer="contextService.currentActionTarget"/>
    <AddLayerPanel v-if="contextService.currentAction=='addLayer'"/>
    </div>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
/* eslint-disable class-methods-use-this */
import Component from 'vue-class-component';
import Map from '@/components/map/Map.vue'; // @ is an alias to /src
import Header from '@/components/Header.vue';
import LeftSideBar from '@/components/LeftSideBar.vue';
import Footer from '@/components/Footer.vue';
import LayerListPanel from '@/components/layers/LayerListPanel.vue';
import MapContext from '@/models/map-context/MapContext';
import AddLayerPanel from '@/components/layers/add-layer-panel/AddLayerPanel.vue';
import GroupLayerInfos from '@/components/layers/GroupLayerInfos.vue';
import SingleLayerInfos from '@/components/layers/SingleLayerInfos.vue';
import FeatureInfosPanel from '@/components/map/FeatureInfosPanel.vue';
import AlertPanel from '@/components/shared/AlertPanel.vue';
import BaseComponent from '@/components/BaseComponent';

import Application from '@/models/map-context/Application';
import { EventBus, EVENTS } from '@/services/EventBus';
import CapabilitiesParser from '@/models/CapabilitiesParser';
import LoadingPanel from '@/components/shared/LoadingPanel.vue';
import FeatureListPanel from '@/components/layers/FeatureListPanel.vue';

// eslint-disable-next-line no-use-before-define
@Component<Home>({
  props: {
  },
  watch: {
    $route(to, from) {
      this.routeChange(to, from);
    },
  },
  components: {
    Map,
    Header,
    LeftSideBar,
    Footer,
    LayerListPanel,
    AddLayerPanel,
    GroupLayerInfos,
    SingleLayerInfos,
    FeatureInfosPanel,
    FeatureListPanel,
    AlertPanel,
    LoadingPanel,
  },
})
export default class Home extends BaseComponent {
  showHeader = true;

  showFooter = true;

  cesiumMap = false;

  mounted() {
    if (this.contextService.configLoaded) {
      this.onConfigLoaded(this.contextService.configuration);
    } else {
      EventBus.$on(EVENTS.CONFIG_LOADED, (config:any) => this.onConfigLoaded(config));
    }
  }

  routeChange(to:any, from:any) {
    console.log(to, from);
    this.onConfigLoaded(this.contextService.configuration);
  }

  onConfigLoaded(config:any) {
    console.log(this.$route);

    // get first from general config
    if (config.header && config.header.show !== undefined) {
      this.showHeader = config.header.show;
    }
    if (config.footer && config.footer.show !== undefined) {
      this.showFooter = config.footer.show;
    }
    const mapId = this.$route.params.id;
    const wmcParam = this.$route.params.wmc;
    const showHeader = this.$route.query.header;

    if (showHeader !== undefined && showHeader === 'false') {
      this.showHeader = false;
    }

    const showFooter = this.$route.query.footer;
    if (showFooter !== undefined && showFooter === 'false') {
      this.showFooter = false;
    }

    console.log(mapId);
    this.contextService.currentContext = null;
    if (wmcParam !== undefined) {
      this.contextService.loadUrl(`./sample_data/contexts/${wmcParam}`).then((reponse) => {
        console.log(reponse.data);
        const newApp = new Application({
          display_name: wmcParam,
        });
        this.capabilitiesService.parseWMC(reponse.data).subscribe((appConfig) => {
          const currentAppConfig = new MapContext(appConfig);
          this.contextService.loadContext(newApp, currentAppConfig);
        });
      }).catch((error) => { EventBus.$emit(EVENTS.ERROR, error); });
    } else if (mapId === undefined) {
      this.contextService.createMap();
      this.contextService.startEdition();
    } else {
      this.contextService
        .getMapById(parseInt(mapId, 10)).then((reponse) => {
          console.log(reponse.data);
          const retour = reponse.data;
          if (retour.config !== undefined) {
          // const appConfig = JSON.parse(retour.config);
            const appConfig = retour.config;
            console.log('loading ', retour.config);
            const application = new Application(retour);
            const currentAppConfig = new MapContext(appConfig);
            this.contextService.loadContext(application, currentAppConfig);
          }
        }).catch((error) => { EventBus.$emit(EVENTS.ERROR, error); });
    }
  }

  get isMapContextLoaded() {
    console.log('isMapContextLoaded', this.contextService.currentContext !== null);
    return this.contextService.currentContext !== null;
  }
}
</script>
<style scoped lang="less">
.home{
  width: 100%;
  height: 100%;
}

.main-area{
  display: flex;
  flex-flow: row wrap;
  /*width: 100vw;

  height: 800px;*/
}
</style>
